%% Imagen de ejemplo
im=imread('Rueda.tif');
figure(2), clf, imshow(im)

%% Fit en una linea
figure(1), clf, imshow(im)
hold on, plot(274:390,ones(size(274:390))*170,'r','linewidth',1.5)

figure(2), clf, plot(274:390,im(170,274:390),'k.-','markersize',20,'linewidth',1)
set(gca,'fontsize',25)
xlabel('x (pix)','fontsize',25)
ylabel('Intensidad','fontsize',25)

In=double(im(170,274:390));
I1=max(In);
I2=min(In);
f=(2*In-I1-I2)/(I1-I2);
pix=274:390;

funcion=inline('tanh(-(pix-x(1))/x(2))','x','pix');
x=lsqcurvefit(funcion,[355 2],double(pix),double(f));

figure(2), hold on
plot(pix,double((I1-I2)/2)*tanh(-(double(pix)-x(1))/x(2))+double((I1+I2)/2),'r','linewidth',1)
plot(x(1),(I1+I2)/2,'or','linewidth',1)

%% Gradiente
Gx=[1 0 -1;2 0 -2;1 0 -1];
Gy=[1 2 1; 0 0 0; -1 -2 -1];
figure(1), clf, imshow(conv2(im,Gx),[])
figure(1), clf, imshow(conv2(im,Gy),[])
figure(1), clf, imshow(sqrt(conv2(im,Gx).^2+conv2(im,Gy).^2),[])

Gmas=[1 0;0 -1];
Gmenos=[0 1; -1 0];
figure(1), clf, imshow(conv2(im,Gmas),[])
figure(1), clf, imshow(conv2(im,Gmenos),[])
figure(1), clf, imshow(sqrt(conv2(im,Gmas).^2+conv2(im,Gmenos).^2),[])

%% Umbral
bordes=sqrt(conv2(im,Gx).^2+conv2(im,Gy).^2);
bordes=bordes*255/(max(max(bordes))-min(min(bordes)));
figure(1), clf, imshow(uint8(bordes))
figure(2), clf, hist(reshape(bordes,1,379*402),100)
set(gca,'fontsize',25)
xlabel('intensidad','fontsize',25)

level=mean(reshape(bordes,1,379*402))+1.5*std(reshape(bordes,1,379*402));
figure(1), clf, imshow(im2bw(uint8(bordes),level/255))









